﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CSharpSamples_Khoshamoz.OOP
{
    class Vehicle
    {

        //سازنده : Constructor
        public Vehicle()
        {
            _NumberOfDoors = 2;
            _NumberOfWheels = 4;
            _TopSpeed = 200;
            _CurrentSpeed = 0;
        }

        private String _Colour;
        public String Colour 
        {
            get 
            {
                return _Colour;            
            }
            set 
            {
                _Colour = value;
            } 
        }

        private int _NumberOfDoors;
        public int NumberOfDoors 
        {
            get 
            {
                return _NumberOfDoors;
            }
            set 
            {
                if (value > 100)
                {
                    _NumberOfDoors = 100;
                }
                else if (value < 0)
                {
                    _NumberOfDoors = 0;
                }
                else
                {
                    _NumberOfDoors = value;
                }
            } 
        }

        private int _NumberOfWheels;
        public int NumberOfWheels 
        {
            get 
            { 
                return _NumberOfWheels; 
            } 
            set 
            { 
                _NumberOfWheels = value; 
            } 
        }

        private int _TopSpeed;
        public int TopSpeed 
        { 
            get 
            { 
                return _TopSpeed; 
            } 
            set 
            { 
                _TopSpeed = value; 
            } 
        }

        private int _Height;
        public int Height 
        {
            get 
            {
                return _Height;
            }
            set 
            {
                _Height = value;
            }
        }

        private int _Width;
        public int Width
        { 
            get 
            {
                return _Width;
            }
            set 
            {
                _Width = value;
            }
        }

        //ReadOnly Property
        public int Area
        { 
            get 
            {
                return _Width * _Height;
            } 
        }

        private int _CurrentSpeed;
        public int CurrentSpeed 
        {
            get 
            {
                return _CurrentSpeed;
            }
        }

        public void Accelerate(int IncreaseSpeedValue)
        {
            _CurrentSpeed += IncreaseSpeedValue;
            if (_CurrentSpeed > _TopSpeed)
                _CurrentSpeed = _TopSpeed;
        }

        public void ReduceSpeed(int DecreaseSpeedValue)
        {
            _CurrentSpeed -= DecreaseSpeedValue;
            if (_CurrentSpeed < 0)
                _CurrentSpeed = 0;
        }

    }
}
